searchNodes=[{"doc":"Supports the CLDR Units definitions which provide for the localization of many unit types.The primary public API defines:Cldr.Unit.to_string/3 which, given a unit or unit list will output a localized stringCldr.Unit.known_units/0 identifies the available units for localizationCldr.Unit.{add, sub, mult, div}/2 to support basic unit mathematics between units of compatible type (like length or volume)Cldr.Unit.compare/2 to compare one unit to another unit as long as they are convertable.Cldr.Unit.convert/2 to convert one unit to another unit as long as they are convertable.Cldr.Unit.localize/3 will convert a unit into the units preferred for a given locale and usageCldr.Unit.preferred_units/3 which, for a given unit and locale, will return a list of preferred units that can be applied to Cldr.Unit.decompose/2Cldr.Unit.decompose/2 to take a unit and return a list of units decomposed by a list of smaller units.","ref":"Cldr.Unit.html","title":"Cldr.Unit","type":"module"},{"doc":"See Cldr.Unit.Math.add/2.","ref":"Cldr.Unit.html#add/2","title":"Cldr.Unit.add/2","type":"function"},{"doc":"See Cldr.Unit.Math.add!/2.","ref":"Cldr.Unit.html#add!/2","title":"Cldr.Unit.add!/2","type":"function"},{"doc":"Returns the base unit for a given Cldr.Unit.t() or atom().Argumentunit is either a t:Cldr.Unit.t() or an atomReturns{:ok, base_unit} or{:error, {exception, reason}}Exampleiex&gt; Cldr.Unit.base_unit :square_kilometer {:ok, :square_meter} iex&gt; Cldr.Unit.base_unit :square_table {:error, {Cldr.UnknownUnitError, &quot;Unknown unit was detected at \\&quot;table\\&quot;&quot;}}","ref":"Cldr.Unit.html#base_unit/1","title":"Cldr.Unit.base_unit/1","type":"function"},{"doc":"Returns a mapping of base units to their respective unit categories.Base units are a common unit for a given unit category which are used in two scenarios:When converting between units. If two units have the same base unit they can be converted to each other. See Cldr.Unit.Conversion.When identifying the preferred units for a given locale or territory, the base unit is used to aid identification of preferences for given use cases. See Cldr.Unit.Preference.Example=&gt; Cldr.Unit.base_unit_category_map %{ &quot;kilogram_square_meter_per_cubic_second_ampere&quot; =&gt; :voltage, &quot;kilogram_meter_per_meter_square_second&quot; =&gt; :torque, &quot;square_meter&quot; =&gt; :area, &quot;kilogram&quot; =&gt; :mass, &quot;kilogram_square_meter_per_square_second&quot; =&gt; :energy, &quot;revolution&quot; =&gt; :angle, &quot;candela_per_square_meter&quot; =&gt; :luminance, ... }","ref":"Cldr.Unit.html#base_unit_category_map/0","title":"Cldr.Unit.base_unit_category_map/0","type":"function"},{"doc":"Returns a mapping from unit categories to the base unit.","ref":"Cldr.Unit.html#base_units/0","title":"Cldr.Unit.base_units/0","type":"function"},{"doc":"See Cldr.Unit.Math.compare/2.","ref":"Cldr.Unit.html#compare/2","title":"Cldr.Unit.compare/2","type":"function"},{"doc":"Returns a boolean indicating if two units are of the same unit category.Argumentsunit_1 and unit_2 are any units returned by Cldr.Unit.new/2 or a valid unit name.Returnstrue or falseExamplesiex&gt; Cldr.Unit.compatible? :foot, :meter true iex&gt; Cldr.Unit.compatible? Cldr.Unit.new!(:foot, 23), :meter true iex&gt; Cldr.Unit.compatible? :foot, :liter false iex&gt; Cldr.Unit.compatible? &quot;light_year_per_second&quot;, &quot;meter_per_gallon&quot; false","ref":"Cldr.Unit.html#compatible?/2","title":"Cldr.Unit.compatible?/2","type":"function"},{"doc":"See Cldr.Unit.Conversion.convert/2.","ref":"Cldr.Unit.html#convert/2","title":"Cldr.Unit.convert/2","type":"function"},{"doc":"See Cldr.Unit.Conversion.convert!/2.","ref":"Cldr.Unit.html#convert!/2","title":"Cldr.Unit.convert!/2","type":"function"},{"doc":"Decomposes a unit into subunits.Any list compatible units can be provided however a list of units of decreasing scale is recommended. For example [:foot, :inch] or [:kilometer, :meter, :centimeter, :millimeter]Argumentsunit is any unit returned by Cldr.Unit.new/2unit_list is a list of valid units (one or more from the list returned by Cldr.Unit.known_units/0. All units must be from the same unit category.format_options is a Keyword list of options that is added to the last unit in unit_list. The format_options will be applied when calling Cldr.Unit.to_string/3 on the unit. The default is [].Returnsa list of units after decomposition or an error tupleExamplesiex&gt; u = Cldr.Unit.new!(10.3, :foot) iex&gt; Cldr.Unit.decompose u, [:foot, :inch] [Cldr.Unit.new!(:foot, 10), Cldr.Unit.new!(:inch, Ratio.new(18, 5))] iex&gt; u = Cldr.Unit.new!(:centimeter, 1111) iex&gt; Cldr.Unit.decompose u, [:kilometer, :meter, :centimeter, :millimeter] [Cldr.Unit.new!(:meter, 11), Cldr.Unit.new!(:centimeter, 11)]","ref":"Cldr.Unit.html#decompose/3","title":"Cldr.Unit.decompose/3","type":"function"},{"doc":"Returns the default formatting style.Exampleiex&gt; Cldr.Unit.default_style :long","ref":"Cldr.Unit.html#default_style/0","title":"Cldr.Unit.default_style/0","type":"function"},{"doc":"See Cldr.Unit.Math.div/2.","ref":"Cldr.Unit.html#div/2","title":"Cldr.Unit.div/2","type":"function"},{"doc":"See Cldr.Unit.Math.div!/2.","ref":"Cldr.Unit.html#div!/2","title":"Cldr.Unit.div!/2","type":"function"},{"doc":"Return a list of known measurement systems.Exampleiex&gt; Cldr.Unit.known_measurement_systems() %{ metric: %{alias: nil, description: &quot;Metric System&quot;}, uksystem: %{ alias: :imperial, description: &quot;UK System of measurement: feet, pints, etc.; pints are 20oz&quot; }, ussystem: %{ alias: nil, description: &quot;US System of measurement: feet, pints, etc.; pints are 16oz&quot; } }","ref":"Cldr.Unit.html#known_measurement_systems/0","title":"Cldr.Unit.known_measurement_systems/0","type":"function"},{"doc":"Returns a list of the known unit categories.Exampleiex&gt; Cldr.Unit.known_unit_categories [:acceleration, :angle, :area, :compound, :concentr, :consumption, :coordinate, :digital, :duration, :electric, :energy, :force, :frequency, :graphics, :length, :light, :mass, :power, :pressure, :speed, :temperature, :torque, :volume]","ref":"Cldr.Unit.html#known_unit_categories/0","title":"Cldr.Unit.known_unit_categories/0","type":"function"},{"doc":"Returns the known units.Known units means units that can be localised directly.Example=&gt; Cldr.Unit.known_units [:acre, :acre_foot, :ampere, :arc_minute, :arc_second, :astronomical_unit, :bit, :bushel, :byte, :calorie, :carat, :celsius, :centiliter, :centimeter, :century, :cubic_centimeter, :cubic_foot, :cubic_inch, :cubic_kilometer, :cubic_meter, :cubic_mile, :cubic_yard, :cup, :cup_metric, :day, :deciliter, :decimeter, :degree, :fahrenheit, :fathom, :fluid_ounce, :foodcalorie, :foot, :furlong, :g_force, :gallon, :gallon_imperial, :generic, :gigabit, :gigabyte, :gigahertz, :gigawatt, :gram, :hectare, :hectoliter, :hectopascal, :hertz, :horsepower, :hour, :inch, ...]","ref":"Cldr.Unit.html#known_units/0","title":"Cldr.Unit.known_units/0","type":"function"},{"doc":"Localizes a unit according to the current processes locale and backend.The curent process's locale is set with Cldr.put_locale/1.See Cldr.Unit.localize/3 for futher details.","ref":"Cldr.Unit.html#localize/1","title":"Cldr.Unit.localize/1","type":"function"},{"doc":"Localizes a unit according to a territoryA territory can be derived from a locale_name or Cldr.LangaugeTag.t().Use this function if you have a unit which should be presented in a user interface using units relevant to the audience. For example, a unit #Cldr.Unit100, :meter&gt; might be better presented to a US audiance as #Cldr.Unit328, :foot&gt;.Argumentsunit is any unit returned by Cldr.Unit.new/2backend is any module that includes use Cldr and therefore is a Cldr backend module.options is a keyword list of optionsOptions:locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct. The default is backend.get_locale/0:territory is any valid territory code returned by Cldr.known_territories/0. The default is the territory defined as part of the :locale. The option :territory has a precedence over the territory in a locale.:usage is the way in which the unit is intended to be used. The available usage varyies according to the unit category. See Cldr.Unit.preferred_units/3.Examplesiex&gt; unit = Cldr.Unit.new!(1.83, :meter) iex&gt; Cldr.Unit.localize(unit, usage: :person_height, territory: :US) [Cldr.Unit.new!(:foot, 6), Cldr.Unit.new!(:inch, Ratio.new(6485183463413016, 137269716642252725))]","ref":"Cldr.Unit.html#localize/3","title":"Cldr.Unit.localize/3","type":"function"},{"doc":"","ref":"Cldr.Unit.html#maybe_translatable_unit/1","title":"Cldr.Unit.maybe_translatable_unit/1","type":"function"},{"doc":"Returns the default measurement system for a territory in a given category.Argumentsterritory is any valid territory returned by Cldr.validate_territory/1category is any measurement system category. The known categories are :default, :temperature and :paper_size. The default category is :default.Examplesiex&gt; Cldr.Unit.measurement_system_for :US :ussystem iex&gt; Cldr.Unit.measurement_system_for :GB :uksystem iex&gt; Cldr.Unit.measurement_system_for :AU :metric iex&gt; Cldr.Unit.measurement_system_for :US, :temperature :ussystem iex&gt; Cldr.Unit.measurement_system_for :GB, :temperature :uksystem","ref":"Cldr.Unit.html#measurement_system_for/2","title":"Cldr.Unit.measurement_system_for/2","type":"function"},{"doc":"Returns a map of measurement systems by territory","ref":"Cldr.Unit.html#measurement_systems/0","title":"Cldr.Unit.measurement_systems/0","type":"function"},{"doc":"See Cldr.Unit.Math.mult/2.","ref":"Cldr.Unit.html#mult/2","title":"Cldr.Unit.mult/2","type":"function"},{"doc":"See Cldr.Unit.Math.mult!/2.","ref":"Cldr.Unit.html#mult!/2","title":"Cldr.Unit.mult!/2","type":"function"},{"doc":"Returns a new Unit.t struct.Argumentsvalue is any float, integer, Ratio or Decimalunit is any unit returned by Cldr.Unit.known_units/0options is Keyword list of options. The default is []Options:use is the intended use of the unit. This is used during localization to convert the unit to that appropriate for the unit category, usage, target territory and unit value. The :use must be known for the unit's category. See Cldr.Unit for more information.Returnsunit or{:error, {exception, message}}Examplesiex&gt; Cldr.Unit.new(23, :gallon) {:ok, Cldr.Unit.new!(:gallon, 23)} iex&gt; Cldr.Unit.new(:gallon, 23) {:ok, Cldr.Unit.new!(:gallon, 23)} iex&gt; Cldr.Unit.new(14, :gadzoots) {:error, {Cldr.UnknownUnitError, &quot;Unknown unit was detected at \\&quot;gadzoots\\&quot;&quot;}}","ref":"Cldr.Unit.html#new/3","title":"Cldr.Unit.new/3","type":"function"},{"doc":"Returns a new Unit.t struct or raises on error.Argumentsvalue is any float, integer or Decimalunit is any unit returned by Cldr.Unit.known_units/0Returnsunit orraises an exceptionExamplesiex&gt; Cldr.Unit.new! 23, :gallon #Cldr.Unit&lt;:gallon, 23&gt; Cldr.Unit.new! 14, :gadzoots ** (Cldr.UnknownUnitError) The unit :gadzoots is not known. (ex_cldr_units) lib/cldr/unit.ex:57: Cldr.Unit.new!/2","ref":"Cldr.Unit.html#new!/3","title":"Cldr.Unit.new!/3","type":"function"},{"doc":"","ref":"Cldr.Unit.html#per_pattern_for/4","title":"Cldr.Unit.per_pattern_for/4","type":"function"},{"doc":"See Cldr.Unit.Preference.preferred_units/3.","ref":"Cldr.Unit.html#preferred_units/3","title":"Cldr.Unit.preferred_units/3","type":"function"},{"doc":"See Cldr.Unit.Preference.preferred_units!/3.","ref":"Cldr.Unit.html#preferred_units!/3","title":"Cldr.Unit.preferred_units!/3","type":"function"},{"doc":"Convert a ratio Unit to a float unit","ref":"Cldr.Unit.html#ratio_to_float/1","title":"Cldr.Unit.ratio_to_float/1","type":"function"},{"doc":"See Cldr.Unit.Math.round/1.","ref":"Cldr.Unit.html#round/1","title":"Cldr.Unit.round/1","type":"function"},{"doc":"See Cldr.Unit.Math.round/2.","ref":"Cldr.Unit.html#round/2","title":"Cldr.Unit.round/2","type":"function"},{"doc":"See Cldr.Unit.Math.round/3.","ref":"Cldr.Unit.html#round/3","title":"Cldr.Unit.round/3","type":"function"},{"doc":"Returns the known styles for a unit.Exampleiex&gt; Cldr.Unit.styles [:long, :short, :narrow]","ref":"Cldr.Unit.html#styles/0","title":"Cldr.Unit.styles/0","type":"function"},{"doc":"See Cldr.Unit.Math.sub/2.","ref":"Cldr.Unit.html#sub/2","title":"Cldr.Unit.sub/2","type":"function"},{"doc":"See Cldr.Unit.Math.sub!/2.","ref":"Cldr.Unit.html#sub!/2","title":"Cldr.Unit.sub!/2","type":"function"},{"doc":"Formats a number into a iolist according to a unit definition for the current process's locale and backend.The curent process's locale is set with Cldr.put_locale/1.See Cldr.Unit.to_iolist/3 for full details.","ref":"Cldr.Unit.html#to_iolist/1","title":"Cldr.Unit.to_iolist/1","type":"function"},{"doc":"Formats a number into an iolist according to a unit definition for a locale.During processing any :format_options of a Unit.t() are merged with options with options taking precedence.Argumentslist_or_number is any number (integer, float or Decimal) or a Cldr.Unit.t() struct or a list of Cldr.Unit.t() structsbackend is any module that includes use Cldr and therefore is a Cldr backend module. The default is Cldr.default_backend/0.options is a keyword list of options.Options:unit is any unit returned by Cldr.Unit.known_units/0. Ignored if the number to be formatted is a Cldr.Unit.t() struct:locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct. The default is Cldr.get_locale/0:style is one of those returned by Cldr.Unit.styles. The current styles are :long, :short and :narrow. The default is style: :long:list_options is a keyword list of options for formatting a list which is passed through to Cldr.List.to_string/3. This is only applicable when formatting a list of units.Any other options are passed to Cldr.Number.to_string/2 which is used to format the numberReturns{:ok, io_list} or{:error, {exception, message}}Examplesiex&gt; Cldr.Unit.to_iolist Cldr.Unit.new!(:gallon, 123), MyApp.Cldr {:ok, [&quot;123&quot;, &quot; gallons&quot;]} iex&gt; Cldr.Unit.to_iolist 123, MyApp.Cldr, unit: :megabyte, locale: &quot;en&quot;, style: :unknown {:error, {Cldr.UnknownFormatError, &quot;The unit style :unknown is not known.&quot;}}","ref":"Cldr.Unit.html#to_iolist/3","title":"Cldr.Unit.to_iolist/3","type":"function"},{"doc":"Formats a number into an iolist according to a unit definition for the current process's locale and backend or raises on error.The curent process's locale is set with Cldr.put_locale/1.See Cldr.Unit.to_iolist!/3 for full details.","ref":"Cldr.Unit.html#to_iolist!/1","title":"Cldr.Unit.to_iolist!/1","type":"function"},{"doc":"Formats a number into an iolist according to a unit definition for the current process's locale and backend or raises on error.During processing any :format_options of a Unit.t() are merged with options with options taking precedence.Argumentsnumber is any number (integer, float or Decimal) or a Cldr.Unit.t() structbackend is any module that includes use Cldr and therefore is a Cldr backend module. The default is Cldr.default_backend/0.options is a keyword listOptions:unit is any unit returned by Cldr.Unit.known_units/0. Ignored if the number to be formatted is a Cldr.Unit.t() struct:locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct. The default is Cldr.get_locale/0:style is one of those returned by Cldr.Unit.available_styles. The current styles are :long, :short and :narrow. The default is style: :longAny other options are passed to Cldr.Number.to_string/2 which is used to format the numberReturnsio_list orraises an exceptionExamplesiex&gt; Cldr.Unit.to_iolist! Cldr.Unit.new!(:gallon, 123), MyApp.Cldr [&quot;123&quot;, &quot; gallons&quot;]","ref":"Cldr.Unit.html#to_iolist!/3","title":"Cldr.Unit.to_iolist!/3","type":"function"},{"doc":"Formats a number into a string according to a unit definition for the current process's locale and backend.The curent process's locale is set with Cldr.put_locale/1.See Cldr.Unit.to_string/3 for full details.","ref":"Cldr.Unit.html#to_string/1","title":"Cldr.Unit.to_string/1","type":"function"},{"doc":"Formats a number into a string according to a unit definition for a locale.During processing any :format_options of a Unit.t() are merged with options with options taking precedence.Argumentslist_or_number is any number (integer, float or Decimal) or a Cldr.Unit.t() struct or a list of Cldr.Unit.t() structsbackend is any module that includes use Cldr and therefore is a Cldr backend module. The default is Cldr.default_backend/0.options is a keyword list of options.Options:unit is any unit returned by Cldr.Unit.known_units/0. Ignored if the number to be formatted is a Cldr.Unit.t() struct:locale is any valid locale name returned by Cldr.known_locale_names/1 or a Cldr.LanguageTag struct. The default is Cldr.get_locale/0:style is one of those returned by Cldr.Unit.styles. The current styles are :long, :short and :narrow. The default is style: :long:list_options is a keyword list of options for formatting a list which is passed through to Cldr.List.to_string/3. This is only applicable when formatting a list of units.Any other options are passed to Cldr.Number.to_string/2 which is used to format the numberReturns{:ok, formatted_string} or{:error, {exception, message}}Examplesiex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:gallon, 123), MyApp.Cldr {:ok, &quot;123 gallons&quot;} iex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:gallon, 1), MyApp.Cldr {:ok, &quot;1 gallon&quot;} iex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:gallon, 1), MyApp.Cldr, locale: &quot;af&quot; {:ok, &quot;1 gelling&quot;} iex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:gallon, 1), MyApp.Cldr, locale: &quot;bs&quot; {:ok, &quot;1 galon&quot;} iex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:gallon, 1234), MyApp.Cldr, format: :long {:ok, &quot;1 thousand gallons&quot;} iex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:gallon, 1234), MyApp.Cldr, format: :short {:ok, &quot;1K gallons&quot;} iex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:megahertz, 1234), MyApp.Cldr {:ok, &quot;1,234 megahertz&quot;} iex&gt; Cldr.Unit.to_string Cldr.Unit.new!(:megahertz, 1234), MyApp.Cldr, style: :narrow {:ok, &quot;1,234MHz&quot;} iex&gt; unit = Cldr.Unit.new!(123, :foot) iex&gt; Cldr.Unit.to_string unit, MyApp.Cldr {:ok, &quot;123 feet&quot;} iex&gt; Cldr.Unit.to_string 123, MyApp.Cldr, unit: :foot {:ok, &quot;123 feet&quot;} iex&gt; Cldr.Unit.to_string Decimal.new(123), MyApp.Cldr, unit: :foot {:ok, &quot;123 feet&quot;} iex&gt; Cldr.Unit.to_string 123, MyApp.Cldr, unit: :megabyte, locale: &quot;en&quot;, style: :unknown {:error, {Cldr.UnknownFormatError, &quot;The unit style :unknown is not known.&quot;}}","ref":"Cldr.Unit.html#to_string/3","title":"Cldr.Unit.to_string/3","type":"function"},{"doc":"Formats a number into a string according to a unit definition for the current process's locale and backend or raises on error.The curent process's locale is set with Cldr.put_locale/1.See Cldr.Unit.to_string!/3 for full details.","ref":"Cldr.Unit.html#to_string!/1","title":"Cldr.Unit.to_string!/1","type":"function"},{"doc":"Formats a number into a string according to a unit definition for the current process's locale and backend or raises on error.During processing any :format_options of a Unit.t() are merged with options with options taking precedence.Argumentsnumber is any number (integer, float or Decimal) or a Cldr.Unit.t() structbackend is any module that includes use Cldr and therefore is a Cldr backend module. The default is Cldr.default_backend/0.options is a keyword listOptions:unit is any unit returned by Cldr.Unit.known_units/0. Ignored if the number to be formatted is a Cldr.Unit.t() struct:locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct. The default is Cldr.get_locale/0:style is one of those returned by Cldr.Unit.available_styles. The current styles are :long, :short and :narrow. The default is style: :longAny other options are passed to Cldr.Number.to_string/2 which is used to format the numberReturnsformatted_string orraises an exceptionExamplesiex&gt; Cldr.Unit.to_string! Cldr.Unit.new!(:gallon, 123), MyApp.Cldr &quot;123 gallons&quot; iex&gt; Cldr.Unit.to_string! Cldr.Unit.new!(:gallon, 1), MyApp.Cldr &quot;1 gallon&quot; iex&gt; Cldr.Unit.to_string! Cldr.Unit.new!(:gallon, 1), MyApp.Cldr, locale: &quot;af&quot; &quot;1 gelling&quot;","ref":"Cldr.Unit.html#to_string!/3","title":"Cldr.Unit.to_string!/3","type":"function"},{"doc":"See Cldr.Unit.known_unit_categories/0.","ref":"Cldr.Unit.html#unit_categories/0","title":"Cldr.Unit.unit_categories/0","type":"function"},{"doc":"Returns the units category for a given unitOptionsunit is any unit returned by Cldr.Unit.new/2Returns{:ok, category} or{:error, {exception, message}}Examplesiex&gt; Cldr.Unit.unit_category :pint_metric {:ok, :volume} iex&gt; Cldr.Unit.unit_category :stone {:ok, :mass}","ref":"Cldr.Unit.html#unit_category/1","title":"Cldr.Unit.unit_category/1","type":"function"},{"doc":"Returns a mapping between Unit categories and the uses they define.","ref":"Cldr.Unit.html#unit_category_usage/0","title":"Cldr.Unit.unit_category_usage/0","type":"function"},{"doc":"","ref":"Cldr.Unit.html#unit_not_translatable_error/1","title":"Cldr.Unit.unit_not_translatable_error/1","type":"function"},{"doc":"","ref":"Cldr.Unit.html#unit_type/1","title":"Cldr.Unit.unit_type/1","type":"function"},{"doc":"","ref":"Cldr.Unit.html#units/0","title":"Cldr.Unit.units/0","type":"function"},{"doc":"","ref":"Cldr.Unit.html#unknown_base_unit_error/1","title":"Cldr.Unit.unknown_base_unit_error/1","type":"function"},{"doc":"Validates a unit style and normalizes it to a standard downcased atom form","ref":"Cldr.Unit.html#validate_style/1","title":"Cldr.Unit.validate_style/1","type":"function"},{"doc":"Validates a unit name and normalizes it,A unit name can be expressed as:an atom() in which case the unit must be localizable in CLDR directlyor a String.t() in which case it is parsed into a list of composable subunits that can be converted but are not guaranteed to be output as a localized string.Argumentsunit_name is an atom() or String.t()Returns{:ok, canonical_unit_name, conversion} where canonical_unit_name is the normalized unit name and conversion is an opaque structure used to convert this this unit into its base unit or{:error, {exception, reason}}NotesA returned unit_name that is an atom is directly localisable (CLDR has translation data for the unit).A unit_name that is a String.t() is composed of one or more unit names that need to be resolved in order for the unit_name to be localised.The difference is an implementation detail and should not be of concern to the user of this library.Examplesiex&gt; Cldr.Unit.validate_unit :meter { :ok, :meter, [meter: %Cldr.Unit.Conversion{base_unit: [:meter], factor: 1, offset: 0}] } iex&gt; Cldr.Unit.validate_unit &quot;meter&quot; {:ok, :meter, [meter: %Cldr.Unit.Conversion{base_unit: [:meter], factor: 1, offset: 0}]} iex&gt; Cldr.Unit.validate_unit &quot;miles_per_liter&quot; {:error, {Cldr.UnknownUnitError, &quot;Unknown unit was detected at \\&quot;s\\&quot;&quot;}} iex&gt; Cldr.Unit.validate_unit &quot;mile_per_liter&quot; {:ok, &quot;mile_per_liter&quot;, {[ mile: %Cldr.Unit.Conversion{ base_unit: [:meter], factor: Ratio.new(905980129838867985, 562949953421312), offset: 0 } ], [ liter: %Cldr.Unit.Conversion{ base_unit: [:cubic_meter], factor: Ratio.new(1152921504606847, 1152921504606846976), offset: 0 } ]}}","ref":"Cldr.Unit.html#validate_unit/1","title":"Cldr.Unit.validate_unit/1","type":"function"},{"doc":"Return the value of the Unit structArgumentsunit is any unit returned by Cldr.Unit.new/2Returnsan integer, float or Decimal representing the amount of the unitExampleiex&gt; Cldr.Unit.value Cldr.Unit.new!(:kilogram, 23) 23","ref":"Cldr.Unit.html#value/1","title":"Cldr.Unit.value/1","type":"function"},{"doc":"Returns a new unit of the same unit type but with a zero value.Argumentunit is any unit returned by Cldr.Unit.new/2Exampleiex&gt; u = Cldr.Unit.new!(:foot, 23.3) #Cldr.Unit&lt;:foot, 23.3&gt; iex&gt; Cldr.Unit.zero(u) #Cldr.Unit&lt;:foot, 0.0&gt;","ref":"Cldr.Unit.html#zero/1","title":"Cldr.Unit.zero/1","type":"function"},{"doc":"Returns a boolean indicating whether a given unit has a zero value.Argumentunit is any unit returned by Cldr.Unit.new/2Examplesiex&gt; u = Cldr.Unit.new!(:foot, 23.3) #Cldr.Unit&lt;:foot, 23.3&gt; iex&gt; Cldr.Unit.zero?(u) false iex&gt; u = Cldr.Unit.new!(:foot, 0) #Cldr.Unit&lt;:foot, 0&gt; iex&gt; Cldr.Unit.zero?(u) true","ref":"Cldr.Unit.html#zero?/1","title":"Cldr.Unit.zero?/1","type":"function"},{"doc":"","ref":"Cldr.Unit.html#t:conversion/0","title":"Cldr.Unit.conversion/0","type":"type"},{"doc":"","ref":"Cldr.Unit.html#t:locale/0","title":"Cldr.Unit.locale/0","type":"type"},{"doc":"","ref":"Cldr.Unit.html#t:style/0","title":"Cldr.Unit.style/0","type":"type"},{"doc":"","ref":"Cldr.Unit.html#t:t/0","title":"Cldr.Unit.t/0","type":"type"},{"doc":"","ref":"Cldr.Unit.html#t:unit/0","title":"Cldr.Unit.unit/0","type":"type"},{"doc":"","ref":"Cldr.Unit.html#t:usage/0","title":"Cldr.Unit.usage/0","type":"type"},{"doc":"","ref":"Cldr.Unit.html#t:value/0","title":"Cldr.Unit.value/0","type":"type"},{"doc":"Functions to manage unit name aliases","ref":"Cldr.Unit.Alias.html","title":"Cldr.Unit.Alias","type":"module"},{"doc":"Un-aliases the provided unit if there is one or return the argument unchanged.","ref":"Cldr.Unit.Alias.html#alias/1","title":"Cldr.Unit.Alias.alias/1","type":"function"},{"doc":"","ref":"Cldr.Unit.Alias.html#aliases/0","title":"Cldr.Unit.Alias.aliases/0","type":"function"},{"doc":"","ref":"Cldr.Unit.Backend.html","title":"Cldr.Unit.Backend","type":"module"},{"doc":"","ref":"Cldr.Unit.Backend.html#define_unit_module/1","title":"Cldr.Unit.Backend.define_unit_module/1","type":"function"},{"doc":"Unit conversion functions for the units defined in Cldr.","ref":"Cldr.Unit.Conversion.html","title":"Cldr.Unit.Conversion","type":"module"},{"doc":"Convert one unit into another unit of the same unit type (length, volume, mass, ...)Argumentsunit is any unit returned by Cldr.Unit.new/2to_unit is any unit name returned by Cldr.Unit.units/0Returnsa Unit.t of the unit type to_unit or{:error, {exception, message}}Examplesiex&gt; Cldr.Unit.convert Cldr.Unit.new!(:mile, 1), :foot {:ok, Cldr.Unit.new!(:foot, 5280)} iex&gt; Cldr.Unit.convert Cldr.Unit.new!(:mile, 1), :gallon {:error, {Cldr.Unit.IncompatibleUnitsError, &quot;Operations can only be performed between units of the same category. Received :mile and :gallon&quot;}}","ref":"Cldr.Unit.Conversion.html#convert/2","title":"Cldr.Unit.Conversion.convert/2","type":"function"},{"doc":"Convert one unit into another unit of the same unit type (length, volume, mass, ...) and raises on a unit type mismatchArgumentsunit is any unit returned by Cldr.Unit.new/2to_unit is any unit name returned by Cldr.Unit.units/0Returnsa Unit.t of the unit type to_unit orraises an exceptionExamplesiex&gt; Cldr.Unit.Conversion.convert!(Cldr.Unit.new!(:celsius, 0), :fahrenheit) ...&gt; |&gt; Cldr.Unit.round #Cldr.Unit&lt;:fahrenheit, 32.0&gt; iex&gt; Cldr.Unit.Conversion.convert!(Cldr.Unit.new!(:fahrenheit, 32), :celsius) ...&gt; |&gt; Cldr.Unit.round #Cldr.Unit&lt;:celsius, 0.0&gt; Cldr.Unit.Conversion.convert Cldr.Unit.new!(:mile, 1), :gallon ** (Cldr.Unit.IncompatibleUnitsError) Operations can only be performed between units of the same type. Received :mile and :gallon","ref":"Cldr.Unit.Conversion.html#convert!/2","title":"Cldr.Unit.Conversion.convert!/2","type":"function"},{"doc":"","ref":"Cldr.Unit.Conversion.html#convert_from_base/2","title":"Cldr.Unit.Conversion.convert_from_base/2","type":"function"},{"doc":"","ref":"Cldr.Unit.Conversion.html#convert_to_base/2","title":"Cldr.Unit.Conversion.convert_to_base/2","type":"function"},{"doc":"Convert a unit into its base unit.For example, the base unit for length is meter. The base unit is an intermediary unit used in all conversions.Argumentsunit is any unit returned by Cldr.Unit.new/2Returnsunit converted to its base unit as a t:Unit.t() or{;error, {exception, reason}} as an errorExampleiex&gt; unit = Cldr.Unit.new!(:kilometer, 10) iex&gt; Cldr.Unit.Conversion.convert_to_base_unit unit {:ok, Cldr.Unit.new!(:meter, 10000)}","ref":"Cldr.Unit.Conversion.html#convert_to_base_unit/1","title":"Cldr.Unit.Conversion.convert_to_base_unit/1","type":"function"},{"doc":"Convert a unit into its base unit and raises on errorFor example, the base unit for length is meter. The base unit is an intermediary unit used in all conversions.Argumentsunit is any unit returned by Cldr.Unit.new/2Returnsunit converted to its base unit as a t:Unit.t() orraises an exceptionExampleiex&gt; unit = Cldr.Unit.new!(:kilometer, 10) iex&gt; Cldr.Unit.Conversion.convert_to_base_unit! unit #Cldr.Unit&lt;:meter, 10000&gt;","ref":"Cldr.Unit.Conversion.html#convert_to_base_unit!/1","title":"Cldr.Unit.Conversion.convert_to_base_unit!/1","type":"function"},{"doc":"","ref":"Cldr.Unit.Conversion.html#t:t/0","title":"Cldr.Unit.Conversion.t/0","type":"type"},{"doc":"","ref":"Cldr.Unit.Conversion.Options.html","title":"Cldr.Unit.Conversion.Options","type":"module"},{"doc":"Simple arithmetic functions for the Unit.t type","ref":"Cldr.Unit.Math.html","title":"Cldr.Unit.Math","type":"module"},{"doc":"Adds two compatible %Unit{} typesOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the sum of unit_1 and the potentially converted unit_2 or{:error, {IncompatibleUnitError, message}}Examplesiex&gt; Cldr.Unit.Math.add Cldr.Unit.new!(:foot, 1), Cldr.Unit.new!(:foot, 1) #Cldr.Unit&lt;:foot, 2&gt; iex&gt; Cldr.Unit.Math.add Cldr.Unit.new!(:foot, 1), Cldr.Unit.new!(:mile, 1) #Cldr.Unit&lt;:foot, 5281&gt; iex&gt; Cldr.Unit.Math.add Cldr.Unit.new!(:foot, 1), Cldr.Unit.new!(:gallon, 1) {:error, {Cldr.Unit.IncompatibleUnitsError, &quot;Operations can only be performed between units of the same category. Received #Cldr.Unit&lt;:foot, 1&gt; and #Cldr.Unit&lt;:gallon, 1&gt;&quot;}}","ref":"Cldr.Unit.Math.html#add/2","title":"Cldr.Unit.Math.add/2","type":"function"},{"doc":"Adds two compatible %Unit{} types and raises on errorOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the sum of unit_1 and the potentially converted unit_2 orRaises an exception","ref":"Cldr.Unit.Math.html#add!/2","title":"Cldr.Unit.Math.add!/2","type":"function"},{"doc":"","ref":"Cldr.Unit.Math.html#cmp/2","title":"Cldr.Unit.Math.cmp/2","type":"function"},{"doc":"Compare two units, converting to a common unit type if required.If conversion is performed, the results are both rounded to a single decimal place before comparison.Returns :gt, :lt, or :eq.Exampleiex&gt; x = Cldr.Unit.new!(:kilometer, 1) iex&gt; y = Cldr.Unit.new!(:meter, 1000) iex&gt; Cldr.Unit.Math.compare x, y :eq","ref":"Cldr.Unit.Math.html#compare/2","title":"Cldr.Unit.Math.compare/2","type":"function"},{"doc":"Divides one compatible %Unit{} type by anotherOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the dividend of unit_1 and the potentially converted unit_2{:error, {IncompatibleUnitError, message}}Examplesiex&gt; Cldr.Unit.div Cldr.Unit.new!(:kilogram, 5), Cldr.Unit.new!(:pound, 1) #Cldr.Unit&lt;:kilogram, 8171193714040401 &lt;|&gt; 90071992547409920&gt; iex&gt; Cldr.Unit.div Cldr.Unit.new!(:pint, 5), Cldr.Unit.new!(:liter, 1) #Cldr.Unit&lt;:pint, 26938398179283203149098379558387912499591752187904 &lt;|&gt; 63733081193714246983132277926414951878417636536165&gt; iex&gt; Cldr.Unit.div Cldr.Unit.new!(:pint, 5), Cldr.Unit.new!(:pint, 1) #Cldr.Unit&lt;:pint, 5.0&gt;","ref":"Cldr.Unit.Math.html#div/2","title":"Cldr.Unit.Math.div/2","type":"function"},{"doc":"Divides one compatible %Unit{} type by another and raises on errorOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the dividend of unit_1 and the potentially converted unit_2Raises an exception","ref":"Cldr.Unit.Math.html#div!/2","title":"Cldr.Unit.Math.div!/2","type":"function"},{"doc":"Multiplies two compatible %Unit{} typesOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the product of unit_1 and the potentially converted unit_2{:error, {IncompatibleUnitError, message}}Examplesiex&gt; Cldr.Unit.mult Cldr.Unit.new!(:kilogram, 5), Cldr.Unit.new!(:pound, 1) #Cldr.Unit&lt;:kilogram, 40855968570202005 &lt;|&gt; 18014398509481984&gt; iex&gt; Cldr.Unit.mult Cldr.Unit.new!(:pint, 5), Cldr.Unit.new!(:liter, 1) #Cldr.Unit&lt;:pint, 134691990896416015745491897791939562497958760939520 &lt;|&gt; 12746616238742849396626455585282990375683527307233&gt; iex&gt; Cldr.Unit.mult Cldr.Unit.new!(:pint, 5), Cldr.Unit.new!(:pint, 1) #Cldr.Unit&lt;:pint, 5&gt;","ref":"Cldr.Unit.Math.html#mult/2","title":"Cldr.Unit.Math.mult/2","type":"function"},{"doc":"Multiplies two compatible %Unit{} types and raises on errorOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the product of unit_1 and the potentially converted unit_2Raises an exception","ref":"Cldr.Unit.Math.html#mult!/2","title":"Cldr.Unit.Math.mult!/2","type":"function"},{"doc":"Rounds the value of a unit.Optionsunit is any unit returned by Cldr.Unit.new/2places is the number of decimal places to round to. The default is 0.mode is the rounding mode to be applied. The default is :half_up.ReturnsA %Unit{} of the same type as unit with a value that is rounded to the specified number of decimal placesRounding modesDirected roundings::down - Round towards 0 (truncate), eg 10.9 rounds to 10.0:up - Round away from 0, eg 10.1 rounds to 11.0. (Non IEEE algorithm):ceiling - Round toward +∞ - Also known as rounding up or ceiling:floor - Round toward -∞ - Also known as rounding down or floorRound to nearest::half_even - Round to nearest value, but in a tiebreak, round towards the nearest value with an even (zero) least significant bit, which occurs 50% of the time. This is the default for IEEE binary floating-point and the recommended value for decimal.:half_up - Round to nearest value, but in a tiebreak, round away from 0. This is the default algorithm for Erlang's Kernel.round/2:half_down - Round to nearest value, but in a tiebreak, round towards 0 (Non IEEE algorithm)Examplesiex&gt; Cldr.Unit.round Cldr.Unit.new!(:yard, 1031.61), 1 #Cldr.Unit&lt;:yard, 1031.6&gt; iex&gt; Cldr.Unit.round Cldr.Unit.new!(:yard, 1031.61), 2 #Cldr.Unit&lt;:yard, 1031.61&gt; iex&gt; Cldr.Unit.round Cldr.Unit.new!(:yard, 1031.61), 1, :up #Cldr.Unit&lt;:yard, 1031.7&gt;","ref":"Cldr.Unit.Math.html#round/3","title":"Cldr.Unit.Math.round/3","type":"function"},{"doc":"Subtracts two compatible %Unit{} typesOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the difference between unit_1 and the potentially converted unit_2{:error, {IncompatibleUnitError, message}}Examplesiex&gt; Cldr.Unit.sub Cldr.Unit.new!(:kilogram, 5), Cldr.Unit.new!(:pound, 1) #Cldr.Unit&lt;:kilogram, -81900798833369519 &lt;|&gt; 18014398509481984&gt; iex&gt; Cldr.Unit.sub Cldr.Unit.new!(:pint, 5), Cldr.Unit.new!(:liter, 1) #Cldr.Unit&lt;:pint, -36794683014431043834033898368027039378825884348261 &lt;|&gt; 12746616238742849396626455585282990375683527307233&gt; iex&gt; Cldr.Unit.sub Cldr.Unit.new!(:pint, 5), Cldr.Unit.new!(:pint, 1) #Cldr.Unit&lt;:pint, 4&gt;","ref":"Cldr.Unit.Math.html#sub/2","title":"Cldr.Unit.Math.sub/2","type":"function"},{"doc":"Subtracts two compatible %Unit{} types and raises on errorOptionsunit_1 and unit_2 are compatible Units returned by Cldr.Unit.new/2ReturnsA %Unit{} of the same type as unit_1 with a value that is the difference between unit_1 and the potentially converted unit_2Raises an exception","ref":"Cldr.Unit.Math.html#sub!/2","title":"Cldr.Unit.Math.sub!/2","type":"function"},{"doc":"Truncates a unit's value","ref":"Cldr.Unit.Math.html#trunc/1","title":"Cldr.Unit.Math.trunc/1","type":"function"},{"doc":"Parse unit strings into composable unit structures. These structures can then be used to produced localized output, or to be converted to another unit of the same unit category.","ref":"Cldr.Unit.Parser.html","title":"Cldr.Unit.Parser","type":"module"},{"doc":"Returns the canonical base unit name for a unit.The base unit is the common unit through which conversions are passed.Argumentsunit_string is any string representing a unit such as light_year_per_week.Returns{:ok, canonical_base_unit} or{:error, {exception, reason}}Examplesiex&gt; Cldr.Unit.Parser.canonical_base_unit &quot;meter&quot; {:ok, :meter} iex&gt; Cldr.Unit.Parser.canonical_base_unit &quot;meter meter&quot; {:ok, :square_meter} iex&gt; Cldr.Unit.Parser.canonical_base_unit &quot;meter per kilogram&quot; {:ok, &quot;meter_per_kilogram&quot;} iex&gt; Cldr.Unit.Parser.canonical_base_unit &quot;yottagram per mile scandinavian&quot; {:ok, &quot;kilogram_per_meter&quot;}","ref":"Cldr.Unit.Parser.html#canonical_base_unit/1","title":"Cldr.Unit.Parser.canonical_base_unit/1","type":"function"},{"doc":"Returns the canonical base unit name for a unit.The base unit is the common unit through which conversions are passed.Argumentsunit_string is any string representing a unit such as light_year_per_week.Returnscanonical_base_unit orraises an exceptionExamplesiex&gt; Cldr.Unit.Parser.canonical_base_unit! &quot;meter&quot; :meter iex&gt; Cldr.Unit.Parser.canonical_base_unit! &quot;meter meter&quot; :square_meter iex&gt; Cldr.Unit.Parser.canonical_base_unit! &quot;meter per kilogram&quot; &quot;meter_per_kilogram&quot; iex&gt; Cldr.Unit.Parser.canonical_base_unit! &quot;yottagram per mile scandinavian&quot; &quot;kilogram_per_meter&quot;","ref":"Cldr.Unit.Parser.html#canonical_base_unit!/1","title":"Cldr.Unit.Parser.canonical_base_unit!/1","type":"function"},{"doc":"Returns the canonical unit name for a unitArgumentsunit_string is any string representing a unit such as light_year_per_week.Returns{:ok, canonical_name} or{:error, {exception, reason}}Examplesiex&gt; Cldr.Unit.Parser.canonical_unit_name &quot;meter&quot; {:ok, :meter} iex&gt; Cldr.Unit.Parser.canonical_unit_name &quot;meter meter&quot; {:ok, :square_meter} iex&gt; Cldr.Unit.Parser.canonical_unit_name &quot;meter per kilogram&quot; {:ok, &quot;meter_per_kilogram&quot;} iex&gt; Cldr.Unit.Parser.canonical_unit_name &quot;meter kilogram&quot; {:ok, &quot;kilogram_meter&quot;} iex&gt; Cldr.Unit.Parser.canonical_unit_name &quot;meter kilogram per fluxom&quot; {:error, {Cldr.UnknownUnitError, &quot;Unknown unit was detected at \\&quot;fluxom\\&quot;&quot;}}","ref":"Cldr.Unit.Parser.html#canonical_unit_name/1","title":"Cldr.Unit.Parser.canonical_unit_name/1","type":"function"},{"doc":"Returns the canonical unit name for a unit or raises on errorArgumentsunit_string is any string representing a unit such as light_year_per_week.Returns{:ok, canonical_name} orraises an exceptionExamplesiex&gt; Cldr.Unit.Parser.canonical_unit_name! &quot;meter&quot; :meter iex&gt; Cldr.Unit.Parser.canonical_unit_name! &quot;meter meter&quot; :square_meter iex&gt; Cldr.Unit.Parser.canonical_unit_name! &quot;meter per kilogram&quot; &quot;meter_per_kilogram&quot; iex&gt; Cldr.Unit.Parser.canonical_unit_name! &quot;meter kilogram&quot; &quot;kilogram_meter&quot; =&gt; Cldr.Unit.Parser.canonical_unit_name! &quot;meter kilogram per fluxom&quot; ** (CaseClauseError) no case clause matching: {:error, {Cldr.UnknownUnitError, &quot;Unknown unit was detected at &quot;fluxom&quot;&quot;}}","ref":"Cldr.Unit.Parser.html#canonical_unit_name!/1","title":"Cldr.Unit.Parser.canonical_unit_name!/1","type":"function"},{"doc":"Parses a unit name expressed as a string and returns the parsed name or an error.Argumentsunit_string is a unit name (such as &quot;meter&quot;) as a String.t()Returns{:ok, normalized_unit} or{:error, {exception, reason}}NotesA normalised unit is a 2-tuple with the first element a list of standard units that are before the first &quot;per&quot; in the unit name. The second element is a list of standard units after the first &quot;per&quot; (if any).The structure of the standard unit is {standard_unit, conversion_to_base_unit}.This function is not normally called by consumers of this library. It is called by Cldr.Unit.validate_unit/1 which is the main public API.Exampleiex&gt; Cldr.Unit.Parser.parse_unit &quot;kilogram per light year&quot; {:ok, {[ {:kilogram, %Cldr.Unit.Conversion{ base_unit: [:kilogram], factor: Ratio.new(144115188075855875, 144115188075855872), offset: 0 }} ], [ {:light_year, %Cldr.Unit.Conversion{ base_unit: [:meter], factor: 9460730000000000, offset: 0 }} ]}}","ref":"Cldr.Unit.Parser.html#parse_unit/1","title":"Cldr.Unit.Parser.parse_unit/1","type":"function"},{"doc":"","ref":"Cldr.Unit.Preference.html","title":"Cldr.Unit.Preference","type":"module"},{"doc":"","ref":"Cldr.Unit.Preference.html#debug/4","title":"Cldr.Unit.Preference.debug/4","type":"function"},{"doc":"","ref":"Cldr.Unit.Preference.html#debug/5","title":"Cldr.Unit.Preference.debug/5","type":"function"},{"doc":"Returns a list of the preferred units for a given unit, locale, territory and use case.The units used to represent length, volume and so on depend on a given territory, measurement system and usage.For example, in the US, people height is most commonly referred to in inches, or informally as feet and inches. In most of the rest of the world it is centimeters.Argumentsunit is any unit returned by Cldr.Unit.new/2.backend is any Cldr backend module. That is, any module that includes use Cldr. The default is Cldr.default_backend/0options is a keyword list of options or a Cldr.Unit.Conversion.Options struct. The default is [].Options:usage is the unit usage. for example ;person for a unit of type :length. The available usage for a given unit category can be seen with Cldr.Config.preferred_units/0. The default is nil.:scope is either :small or nil. In some usage, the units used are different when the unit size is small. It is up to the developer to determine when scope: :small is appropriate.:alt is either :informal or nil. Like :scope, the units in use depend on whether they are being used in a formal or informal context.:locale is any locale returned by Cldr.validate_locale/2Returns{:ok, unit_list} or{:error, {exception, reason}}Examplesiex&gt; meter = Cldr.Unit.new!(:meter, 1) iex&gt; Cldr.Unit.Preference.preferred_units meter, MyApp.Cldr, locale: &quot;en-US&quot;, usage: :person {:ok, [:inch], []} iex&gt; Cldr.Unit.Preference.preferred_units meter, MyApp.Cldr, locale: &quot;en-AU&quot;, usage: :person {:ok, [:centimeter], []} iex&gt; Cldr.Unit.Preference.preferred_units meter, MyApp.Cldr, locale: &quot;en-US&quot;, usage: :road {:ok, [:foot], [round_nearest: 10]} iex&gt; Cldr.Unit.Preference.preferred_units meter, MyApp.Cldr, locale: &quot;en-AU&quot;, usage: :road {:ok, [:meter], [round_nearest: 10]}NotesOne common pattern is to convert a given unit into the unit appropriate for a given local and usage. This can be accomplished with a combination of Cldr.Unit.Preference.preferred_units/3 and Cldr.Unit.decompose/2. For example:iex&gt; meter = Cldr.Unit.new!(:meter, 1) iex&gt; preferred_units = Cldr.Unit.Preference.preferred_units(meter, ...&gt; MyApp.Cldr, locale: &quot;en-US&quot;, usage: :person) iex&gt; with {:ok, preferred_units, _} &lt;- preferred_units do ...&gt; Cldr.Unit.decompose(meter, preferred_units) ...&gt; end [Cldr.Unit.new!(:inch, Ratio.new(216172782113783808, 5490788665690109))]","ref":"Cldr.Unit.Preference.html#preferred_units/3","title":"Cldr.Unit.Preference.preferred_units/3","type":"function"},{"doc":"","ref":"Cldr.Unit.Preference.html#preferred_units/4","title":"Cldr.Unit.Preference.preferred_units/4","type":"function"},{"doc":"Returns a list of the preferred units for a given unit, locale, territory and use case.The units used to represent length, volume and so on depend on a given territory, measurement system and usage.For example, in the US, people height is most commonly referred to in inches, or feet and inches. In most of the rest of the world it is centimeters.Argumentsunit is any unit returned by Cldr.Unit.new/2.backend is any Cldr backend module. That is, any module that includes use Cldr. The default is Cldr.default_backend/0options is a keyword list of options or a Cldr.Unit.Conversion.Options struct. The default is [].Options:locale is any valid locale name returned by Cldr.known_locale_names/0 or a Cldr.LanguageTag struct. The default is backend.get_locale/0:territory is any valid territory code returned by Cldr.known_territories/0. The default is the territory defined as part of the :locale. The option :territory has a precedence over the territory in a locale.:usage is the way in which the unit is intended to be used. The available usage varyies according to the unit category. See Cldr.Unit.preferred_units/3.Returnsunit_list orraises an exceptionNoteThis function, unlike Cldr.Unit.preferred_units/3 does not return any available formatting hints.Examplesiex&gt; meter = Cldr.Unit.new!(:meter, 1) iex&gt; Cldr.Unit.Preference.preferred_units! meter, MyApp.Cldr, locale: &quot;en-US&quot;, usage: :person_height [:foot, :inch] iex&gt; Cldr.Unit.Preference.preferred_units! meter, MyApp.Cldr, locale: &quot;en-US&quot;, usage: :person [:inch] iex&gt; Cldr.Unit.Preference.preferred_units! meter, MyApp.Cldr, locale: &quot;en-AU&quot;, usage: :person [:centimeter] iex&gt; Cldr.Unit.Preference.preferred_units! meter, MyApp.Cldr, locale: &quot;en-US&quot;, usage: :road [:foot] iex&gt; Cldr.Unit.Preference.preferred_units! meter, MyApp.Cldr, locale: &quot;en-AU&quot;, usage: :road [:meter]","ref":"Cldr.Unit.Preference.html#preferred_units!/3","title":"Cldr.Unit.Preference.preferred_units!/3","type":"function"},{"doc":"","ref":"Cldr.Unit.Preference.html#unknown_preferences_error/4","title":"Cldr.Unit.Preference.unknown_preferences_error/4","type":"function"},{"doc":"","ref":"Cldr.Unit.Preference.html#unknown_usage_error/2","title":"Cldr.Unit.Preference.unknown_usage_error/2","type":"function"},{"doc":"","ref":"Cldr.Unit.Preference.html#validate_usage/2","title":"Cldr.Unit.Preference.validate_usage/2","type":"function"},{"doc":"","ref":"Cldr.Unit.Prefix.html","title":"Cldr.Unit.Prefix","type":"module"},{"doc":"","ref":"Cldr.Unit.Prefix.html#power_units/0","title":"Cldr.Unit.Prefix.power_units/0","type":"function"},{"doc":"","ref":"Cldr.Unit.Prefix.html#si_factors/0","title":"Cldr.Unit.Prefix.si_factors/0","type":"function"},{"doc":"","ref":"Cldr.Unit.Prefix.html#si_power_prefixes/0","title":"Cldr.Unit.Prefix.si_power_prefixes/0","type":"function"},{"doc":"","ref":"Cldr.Unit.Prefix.html#si_sort_order/0","title":"Cldr.Unit.Prefix.si_sort_order/0","type":"function"},{"doc":"","ref":"Cldr.Unit.IncompatibleUnitsError.html","title":"Cldr.Unit.IncompatibleUnitsError","type":"exception"},{"doc":"","ref":"Cldr.Unit.UnitNotConvertibleError.html","title":"Cldr.Unit.UnitNotConvertibleError","type":"exception"},{"doc":"","ref":"Cldr.Unit.UnitNotTranslatableError.html","title":"Cldr.Unit.UnitNotTranslatableError","type":"exception"},{"doc":"","ref":"Cldr.Unit.UnknownBaseUnitError.html","title":"Cldr.Unit.UnknownBaseUnitError","type":"exception"},{"doc":"","ref":"Cldr.Unit.UnknownUnitCategoryError.html","title":"Cldr.Unit.UnknownUnitCategoryError","type":"exception"},{"doc":"","ref":"Cldr.Unit.UnknownUnitPreferenceError.html","title":"Cldr.Unit.UnknownUnitPreferenceError","type":"exception"},{"doc":"","ref":"Cldr.Unit.UnknownUsageError.html","title":"Cldr.Unit.UnknownUsageError","type":"exception"},{"doc":"Cldr for Units","ref":"readme.html","title":"Cldr for Units","type":"extras"},{"doc":"Note that :ex_cldr_units requires Elixir 1.6 or later.Add ex_cldr_units as a dependency to your mix project:defp deps do [ {:ex_cldr_units, &quot;~&gt; 3.0&quot;} ] endthen retrieve ex_cldr_units from hex:mix deps.get mix deps.compile","ref":"readme.html#installation","title":"Cldr for Units - Installation","type":"extras"},{"doc":"ex_cldr_units is an add-on library for ex_cldr that provides localisation and formatting for units such as weights, lengths, areas, volumes and so on. It also provides unit conversion and simple arithmetic for compatible units.ConfigurationFrom ex_cldr version 2.0, a backend module must be defined into which the public API and the CLDR data is compiled. See the ex_cldr documentation for further information on configuration.In the following examples we assume the presence of a module called MyApp.Cldr defined as:defmodule MyApp.Cldr do use Cldr, locales: [&quot;en&quot;, &quot;fr&quot;], default_locale: &quot;en&quot;, providers: [Cldr.Number, Cldr.Unit, Cldr.List] endSupporting the String.Chars protocolThe String.Chars protocol underpins Kernel.to_string/1 and is also used in string interpolation such as \#{my_unit}. In order for this to be supported by Cldr.Unit, a default backend module must be configured in config.exs. For example:config :ex_cldr_units, default_backend: MyApp.Cldr","ref":"readme.html#getting-started","title":"Cldr for Units - Getting Started","type":"extras"},{"doc":"The primary api is defined by three functions:MyApp.Cldr.Unit.to_string/2 for formatting unitsMyApp.Cldr.Unit.new/2 to create a new Unit.t struct that encapsulated a unit and a value that can be used for arithmetic, comparison and conversionMyApp.Cldr.Unit.convert/2 to convert one compatible unit to anotherMyApp.Cldr.Unit.localize/3 to localize a unit by converting it to units customary for a given territoryMyApp.Cldr.Unit.add/2, MyApp.Cldr.Unit.sub/2, MyApp.Cldr.Unit.mult/2, MyApp.Cldr.Unit.div/2 provide basic arithmetic operations on compatible Unit.t structs.Creating a new unitA Cldr.Unit.t() struct is created with the Cldr.Unit.new/2 function. The two parameters are a unit name and a number (expressed as a float, integer, Decimal or Ratio) in either order.Naming units is quite flexible combining:One or more base unit names. These are the names returned from Cldr.Unit.known_units/0An optional SI prefix (from yokto to yotta)An optional power prefix of square or cubicNames can be expressed as strings with any of -, _ or as separators between words.Some examples:iex&gt; Cldr.Unit.new :meter, 1 {:ok, #Cldr.Unit&lt;:meter, 1&gt;} iex&gt; Cldr.Unit.new &quot;square meter&quot;, 1 {:ok, #Cldr.Unit&lt;:square_meter, 1&gt;} iex&gt; Cldr.Unit.new &quot;square liter&quot;, 1 {:ok, #Cldr.Unit&lt;&quot;square_liter&quot;, 1&gt;} iex&gt; Cldr.Unit.new &quot;square yottaliter&quot;, 1 {:ok, #Cldr.Unit&lt;&quot;square_yottaliter&quot;, 1&gt;} iex&gt; Cldr.Unit.new &quot;cubic light year&quot;, 1 {:ok, #Cldr.Unit&lt;&quot;cubic_light_year&quot;, 1&gt;} iex&gt; Cldr.Unit.new &quot;squre meter&quot;, 1 {:error, {Cldr.UnknownUnitError, &quot;Unknown unit was detected at \\&quot;squre_meter\\&quot;&quot;}}You will note that the unit make not make logical sense (cubic light-year?) but they do make mathematical sense.Units can also be described as the product of one or more base units. For example:iex&gt; Cldr.Unit.new &quot;liter ampere&quot;, 1 {:ok, #Cldr.Unit&lt;&quot;ampere_liter&quot;, 1&gt;} iex&gt; Cldr.Unit.new &quot;mile lux&quot;, 1 {:ok, #Cldr.Unit&lt;&quot;mile_lux&quot;, 1&gt;}Again, this may not have a logical meaning but they do have an arithmetic meaning and they can be formatted as strings:iex&gt; Cldr.Unit.new!(&quot;liter ampere&quot;, 1) |&gt; Cldr.Unit.to_string {:ok, &quot;1 ampere⋅litre&quot;} iex&gt; Cldr.Unit.new!(&quot;mile lux&quot;, 3) |&gt; Cldr.Unit.to_string {:ok, &quot;3 miles⋅lux&quot;}Lastly, there are units formed by division where are called &quot;per&quot; units. For example:iex&gt; Cldr.Unit.new &quot;mile per hour&quot;, 1 {:ok, #Cldr.Unit&lt;:mile_per_hour, 1&gt;} iex&gt; Cldr.Unit.new &quot;liter per second&quot;, 1 {:ok, #Cldr.Unit&lt;&quot;liter_per_second&quot;, 1&gt;} iex&gt; Cldr.Unit.new &quot;cubic gigalux per inch&quot;, 1 {:ok, #Cldr.Unit&lt;&quot;cubic_gigalux_per_inch&quot;, 1&gt;}Unit formatting and localizationMyApp.Cldr.Unit.to_string/2 provides localized unit formatting. It supports two arguments:number is any number (integer, float or Decimal) or a Unit.t struct returned by Cldr.Unit.new/2options which are::unit is any unit returned by Cldr.Unit.units/0. This option is required unless a Unit.t is passed as the first argument.:locale is any configured locale. See Cldr.known_locale_names/0. The default is locale: Cldr.get_current_locale():style is one of those returned by Cldr.Unit.available_styles. The current styles are :long, :short and :narrow. The default is style: :longAny other options are passed to Cldr.Number.to_string/2 which is used to format the numberiex&gt; MyApp.Cldr.Unit.to_string 123, unit: :gallon {:ok, &quot;123 gallons&quot;} iex&gt; MyApp.Cldr.Unit.to_string 1234, unit: :gallon, format: :long {:ok, &quot;1 thousand gallons&quot;} iex&gt; MyApp.Cldr.Unit.to_string 1234, unit: :gallon, format: :short {:ok, &quot;1K gallons&quot;} iex&gt; MyApp.Cldr.Unit.to_string 1234, unit: :megahertz {:ok, &quot;1,234 megahertz&quot;} iex&gt; MyApp.Cldr.Unit.to_string 1234, unit: :foot, locale: &quot;fr&quot; {:ok, &quot;1 234 pieds&quot;} iex&gt; MyApp.Cldr.Unit.to_string Cldr.Unit.new(:ampere, 42), locale: &quot;fr&quot; {:ok, &quot;42 ampères&quot;} iex&gt; Cldr.Unit.to_string 1234, MyApp.Cldr, unit: &quot;foot_per_second&quot;, style: :narrow, per: :second {:ok, &quot;1,234′/s&quot;} iex&gt; Cldr.Unit.to_string 1234, MyApp.Cldr, unit: &quot;foot_per_second&quot; {:ok, &quot;1,234 feet per second&quot;} Unit decompositionSometimes its a requirement to decompose a unit into one or more subunits. For example, if someone is 6.3 feet heigh we would normally say &quot;6 feet, 4 inches&quot;. This can be achieved with Cldr.Unit.decompose/2. Using our example:iex&gt; height = Cldr.Unit.new(:foot, 6.3) #Cldr.Unit&lt;:foot, 6.3&gt; iex(2)&gt; Cldr.Unit.decompose height, [:foot, :inch] [#Cldr.Unit&lt;:foot, 6.0&gt;, #Cldr.Unit&lt;:inch, 4.0&gt;]A localised string representing this decomposition can also be produced. Cldr.Unit.to_string/3 will process a unit list, using the function Cldr.List.to_string/2 to perform the list combination. Again using the example:iex&gt; c = Cldr.Unit.decompose height, [:foot, :inch] [#Cldr.Unit&lt;:foot, 6.0&gt;, #Cldr.Unit&lt;:inch, 4.0&gt;] iex&gt; Cldr.Unit.to_string c, MyApp.Cldr &quot;6 feet and 4 inches&quot; iex&gt; Cldr.Unit.to_string c, MyApp.Cldr, list_options: [format: :unit_short] &quot;6 feet, 4 inches&quot; # And of course full localisation is supported iex&gt; Cldr.Unit.to_string c, MyApp.Cldr, locale: &quot;fr&quot; &quot;6 pieds et 4 pouces&quot;Converting UnitsUnit.t structs can be converted to other compatible units. For example, feet can be converted to meters since they are both the length unit type.# Test for unit compatibility iex&gt; MyApp.Cldr.Unit.compatible? :foot, :meter true iex&gt; MyApp.Cldr.Unit.compatible? :foot, :liter false # Convert a unit iex&gt; MyApp.Cldr.Unit.convert MyApp.Cldr.Unit.new(:foot, 3), :meter #Cldr.Unit&lt;:meter, 0.9144111192392099&gt; Localising units for a give locale or territoryDiffernent locales or territories use different measurement systems and sometimes different measurement scales that also vary based upon usage. For example, in the US a person's height is considered in inches up to a certain point and feet and inches after that. For distances when driving, the length is considered in yards for certain distances and miles after that. For most other countries the same quantity would be expressed in centimeters or meters or kilometers.ex_cldr_units makes it easy to take a unit and convert it to the units appropriate for a given locale and usage.Consider this example:iex&gt; height = Cldr.Unit.new!(1.81, :meter) #Cldr.Unit&lt;:meter, 1.81&gt; iex&gt; us_height = Cldr.Unit.localize height, usage: :person_height, territory: :US [#Cldr.Unit&lt;:foot, 5&gt;, #Cldr.Unit&lt;:inch, 1545635392113553812 &lt;|&gt; 137269716642252725&gt;] iex&gt; Cldr.Unit.to_string us_height {:ok, &quot;5 feet and 11.26 inches&quot;}Note that conversion is dependent on context. The context above is :person_height reflecting that we are referring to the height of a person. For units of length category, the other contexts available are :rainfall, :snowfall, :vehicle, :visibility and :road. Using the above example with the context of :rainfall we seeiex&gt; length = Cldr.Unit.localize height, usage: :rainfall, territory: :US [#Cldr.Unit&lt;:inch, 9781818390648717312 &lt;|&gt; 137269716642252725&gt;] iex&gt; Cldr.Unit.to_string length {:ok, &quot;71.26 inches&quot;}See Cldr.Unit.preferred_units/3 to see what mappings are available, in particular what context usage is supported for conversion.Unit arithmeticBasic arithmetic is provided by Cldr.Unit.add/2, Cldr.Unit.sub/2, Cldr.Unit.mult/2, Cldr.Unit.div/2 as well as Cldr.Unit.round/3iex&gt; MyApp.Cldr.Unit.Math.add MyApp.Cldr.Unit.new!(:foot, 1), MyApp.Cldr.Unit.new!(:foot, 1) #Cldr.Unit&lt;:foot, 2&gt; iex&gt; MyApp.Cldr.Unit.Math.add MyApp.Cldr.Unit.new!(:foot, 1), MyApp.Cldr.Unit.new!(:mile, 1) #Cldr.Unit&lt;:foot, 5280.945925937846&gt; iex&gt; MyApp.Cldr.Unit.Math.add MyApp.Cldr.Unit.new!(:foot, 1), MyApp.Cldr.Unit.new!(:gallon, 1) {:error, {Cldr.Unit.IncompatibleUnitError, &quot;Operations can only be performed between units of the same type. Received #Cldr.Unit&lt;:foot, 1&gt; and #Cldr.Unit&lt;:gallon, 1&gt;&quot;}} iex&gt; MyApp.Cldr.Unit.round MyApp.Cldr.Unit.new(:yard, 1031.61), 1 #Cldr.Unit&lt;:yard, 1031.6&gt; iex&gt; MyApp.Cldr.Unit.round MyApp.Cldr.Unit.new(:yard, 1031.61), 1, :up #Cldr.Unit&lt;:yard, 1031.7&gt; Available unitsAvailable units are returned by MyApp.Cldr.Unit.known_units/0.iex&gt; MyApp.Cldr.Unit.known_units [:acre, :acre_foot, :ampere, :arc_minute, :arc_second, :astronomical_unit, :bit, :bushel, :byte, :calorie, :carat, :celsius, :centiliter, :centimeter, :century, :cubic_centimeter, :cubic_foot, :cubic_inch, :cubic_kilometer, :cubic_meter, :cubic_mile, :cubic_yard, :cup, :cup_metric, :day, :deciliter, :decimeter, :degree, :fahrenheit, :fathom, :fluid_ounce, :foodcalorie, :foot, :furlong, :g_force, :gallon, :gallon_imperial, :generic, :gigabit, :gigabyte, :gigahertz, :gigawatt, :gram, :hectare, :hectoliter, :hectopascal, :hertz, :horsepower, :hour, :inch, ...]Unit typesUnits are grouped by unit type which defines the convertibility of different types. In general, units of the same time are convertible to each other. The function MyApp.Cldr.Unit.known_unit_categories/0 returns the unit types.iex&gt; MyApp.Cldr.Unit.known_unit_categories [:acceleration, :angle, :area, :concentr, :consumption, :coordinate, :digital, :duration, :electric, :energy, :frequency, :length, :light, :mass, :power, :pressure, :speed, :temperature, :volume]Sorting UnitsWith Elixir 1.10, Enum.sort/2 supports module-based comparisons to provide a simpler API for sorting structs. ex_cldr_units supports Elixir 1.10 as the following example shows:iex&gt; alias Cldr.Unit Cldr.Unit iex&gt; unit_list = [Unit.new(:millimeter, 100), Unit.new(:centimeter, 100), Unit.new(:meter, 100), Unit.new(:kilometer, 100)] [#Unit&lt;:millimeter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:kilometer, 100&gt;] iex&gt; Enum.sort unit_list, Cldr.Unit [#Unit&lt;:millimeter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:kilometer, 100&gt;] iex&gt; Enum.sort unit_list, {:desc, Cldr.Unit} [#Unit&lt;:kilometer, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:millimeter, 100&gt;] iex&gt; Enum.sort unit_list, {:asc, Cldr.Unit} [#Unit&lt;:millimeter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:kilometer, 100&gt;]","ref":"readme.html#public-api","title":"Cldr for Units - Public API","type":"extras"},{"doc":"For help in iex:iex&gt; h MyApp.Cldr.Unit.new iex&gt; h MyApp.Cldr.Unit.to_string iex&gt; h MyApp.Cldr.Unit.localize iex&gt; h MyApp.Cldr.Unit.convert iex&gt; h MyApp.Cldr.Unit.units iex&gt; h MyApp.Cldr.Unit.unit_categories","ref":"readme.html#further-information","title":"Cldr for Units - Further information","type":"extras"},{"doc":"Changelog for Cldr_Units v3.1.2This is the changelog for Cldr_units v3.1.2 released on August 29th, 2020. For older changelogs please consult the release tag on GitHubBug FixesFixes dialyzer warning on Cldr.Unit.to_string/3 and Cldr.Unit.to_string!/3. Thanks to @maennchen for the report. Closes #15.Support Decimal numbers in Cldr.Unit.to_string/3 and Cldr.Unit.to_string!/3.Changelog for Cldr_Units v3.1.1This is the changelog for Cldr_units v3.1.1 released on June 29th, 2020. For older changelogs please consult the release tag on GitHubBug FixesEnsure that :locale is passed through to Cldr.Number.to_string/3. Thanks for the PR to @Zurga. Closes #14.Changelog for Cldr_Units v3.1.0This is the changelog for Cldr_units v3.1.0 released on May 18th, 2020. For older changelogs please consult the release tag on GitHubEnhancementsAdd Cldr.Unit.to_iolist/3 and Cldr.Unit.to_iolist!/3 to return the formatted unit as an iolist rather than a string. This allows for formatting the number and the unit name differently. It also allows some efficiency in inserting formatted content into a Phoenix workflow since it handles iolists efficiently.Bug FixesFix resolving translatable unit names from stringsFix converting translatable units that have a &quot;per&quot; conversionChangelog for Cldr_Units v3.0.1This is the changelog for Cldr_units v3.0.1 released on May 15th, 2020. For older changelogs please consult the release tag on GitHubBug FixesCorrects unit creation when the unit itself is directly translatable (like :kilowatt_hour) but there is no explicit conversion, just an implicit calculated conversion. Thanks to @syfgkjasdkn.Changelog for Cldr_Units v3.0.0This is the changelog for Cldr_units v3.0.0 released on May 4th, 2020. For older changelogs please consult the release tag on GitHubSummaryNew unit creation including rational numbersBase unit calculationNew unit preferencesNew conversion engineBreaking changesCldr.Unit.new/2 is now Cldr.Unit/{2, 3} and it returns a standard {:ok, unit} tuple on success. Use Cldr.Unit.new!/{2,3} if you want to retain the previous behaviour.Removed Cldr.Unit.unit_tree/0Removed Cldr.Unit.units/1Removed Cldr.Unit.compatible_units/2Removed Cldr.Unit.best_match/1Removed Cldr.Unit.jaro_match/1Removed Cldr.Unit.unit_category_map/0 (replaced with Cldr.Unit.base_unit_category_map/0)DeprecationsDeprecate Cldr.Unit.unit_categories/0 in favour of Cldr.Unit.known_unit_categories/0 to be consistent across CLDR.EnhancementsIncorporate CLDR's unit conversion data into the new conversion engineUnit values may now be rational numbers. Conversion data and the results of conversions are executed and retained as rationals. New units can be created with integer, float, Decimal or rational numbers. Conversion to floats is done only when the unit is output via Cldr.Unit.to_string/3 or explicitly through the new function Cldr.Unit.ratio_to_float/1Add an option :usage to Cldr.Unit.new/{2,3}. This defines an expected usage for a given unit that will be applied during localization. The default is :default. See Cldr.Unit.unit_category_map/0 for what usage is defined for a unit category.Add Cldr.Unit.known_measurement_sytems/0 to return the known measurement systemsAdd Cldr.Unit.Conversion.preferred_units/3 that returns a list of preferred units for a given unit. This makes it straight forward to take a unit and convert it to the units preferred by the user for a given unit type, locale and use case.Add Cldr.Unit.base_category_map/0 that maps base units to their unit categories. For example, map mile_per_hour to :speed or kilogram_square_meter_per_cubic_second_ampere to :voltage. Base units are derived from a unit name and are not normally the concern of the consumer of ex_cldr_units.Changelog for Cldr_Units v2.8.1This is the changelog for Cldr_units v2.8.1 released on April 25th, 2020. For older changelogs please consult the release tag on GitHubEnhancementsUpdates data management to be compatible with data from both both CLDR 36 (ex_cldr 2.13) and CLDR 37 (ex_cldr 2.14)Changelog for Cldr_Units v2.8.0This is the changelog for Cldr_units v2.8.0 released on January 27th, 2020. For older changelogs please consult the release tag on GitHubEnhancementsSupport the new Enum.sort/2 in Elixir 1.10. The function Cldr.Math.cmp/2 is deprecated in favour of Cldr.Math.compare/2 that has the same function signature and returns the same result that is compatible with Elixir 1.10.Adds Cldr.Unit.compare/2 that is required for Enum.sort/2 to work as expected with units.As an example:iex&gt; alias Cldr.Unit Cldr.Unit iex&gt; unit_list = [Unit.new(:millimeter, 100), Unit.new(:centimeter, 100), Unit.new(:meter, 100), Unit.new(:kilometer, 100)] [#Unit&lt;:millimeter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:kilometer, 100&gt;] iex&gt; Enum.sort unit_list, Cldr.Unit [#Unit&lt;:millimeter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:kilometer, 100&gt;] iex&gt; Enum.sort unit_list, {:desc, Cldr.Unit} [#Unit&lt;:kilometer, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:millimeter, 100&gt;] iex&gt; Enum.sort unit_list, {:asc, Cldr.Unit} [#Unit&lt;:millimeter, 100&gt;, #Unit&lt;:centimeter, 100&gt;, #Unit&lt;:meter, 100&gt;, #Unit&lt;:kilometer, 100&gt;]Changelog for Cldr_Units v2.7.0This is the changelog for Cldr_units v2.7.0 released on October 10th, 2019. For older changelogs please consult the release tag on GitHubEnhancementsUpdate ex_cldr to version 2.11.0 which encapsulates CLDR version 36.0.0 data.Update minimum Elixir version to 1.6Adds conversion for newton meter, dalton, solar luminosity, pound foot, bar, newton, electron volt, barrel, dunam, decade, mole, pound force, megapascal, pascal, kilopascal, solar radius, therm US, British thermal unit, earth mass.Changelog for Cldr_Units v2.6.1This is the changelog for Cldr_units v2.6.1 released on August 31st, 2019. For older changelogs please consult the release tag on GitHubBug FixesFix Cldr.Unit.to_string/3 to ensure that {:ok, string} is returned when formatting a list of unitsChangelog for Cldr_Units v2.6.0This is the changelog for Cldr_units v2.6.0 released on August 25th, 2019. For older changelogs please consult the release tag on GitHubEnhancementsAdd Cldr.Unit.localize/3 to support converting a given unit into units that are familiar to a given territory. For example, given a unit of #Unit&lt;2, :meter&gt; is would normally be expected to show this as [#Unit&lt;:foot, 5&gt;, #Unit&lt;:inch, 11&gt;]. The data to support these conversions is returned by Cldr.Unit.unit_preferences/0. An example: iex&gt; height = Cldr.Unit.new(1.8, :meter) iex&gt; Cldr.Unit.localize height, :person, territory: :US, style: :informal [#Unit&lt;:foot, 5&gt;, #Unit&lt;:inch, 11&gt;]Note that conversion is dependent on context. The context above is :person reflecting that we are referring to the height of a person. For units of length category, the other contexts available are :rainfall, :snowfall, :vehicle, :visibility and :road. Using the above example with the context of :rainfall we see iex&gt; Cldr.Unit.localize height, :rainfall, territory: :US [#Unit&lt;:inch, 71&gt;]Adds a :per option to Cldr.Unit.to_string/3. This option leverages the per formatting style to allow compound units to be printed. For example, assume want to emit a string which represents &quot;kilograms per second&quot;. There is no such unit defined in CLDR (or perhaps anywhere!). But if we define the unit unit = Cldr.Unit.new(:kilogram, 20) we can then execute Cldr.Unit.to_string(unit, per: :second). Each locale defines a specific way to format such a compount unit. Usually it will return something like 20 kilograms/secondAdds Cldr.Unit.unit_preferences/0 to map units into a territory preference alternative unitAdds Cldr.Unit.measurement_systems/0 that identifies the unit system in use for a territoryAdds Cldr.Unit.measurement_system_for/1 that returns the measurement system in use for a given territory. The result will be one of :metric, :US or :UK.DeprecationAdd Cldr.Unit.unit_category/1 and deprecate Cldr.Unit.unit_type/1 in order to be consistent with the nomenclature of CLDRChangelog for Cldr_Units v2.5.3This is the changelog for Cldr_units v2.5.3 released on August 23rd, 2019. For older changelogs please consult the release tag on GitHubBug FixesFix @spec for Cldr.Unit.to_string/3 and Cldr.Unit.to_string!/3Changelog for Cldr_Units v2.5.2This is the changelog for Cldr_units v2.5.2 released on August 21st, 2019. For older changelogs please consult the release tag on GitHubBug FixesReplace Cldr.get_current_locale/0 with Cldr.get_locale/0in docsFix dialyzer warningsChangelog for Cldr_Units v2.5.1This is the changelog for Cldr_units v2.5.1 released on June 18th, 2019. For older changelogs please consult the release tag on GitHubEnhancementsStandardize the development cldr backend as MyApp.Cldr which makes for more understandable and readable examples and doc testsCldr.Unit.to_string/3 now allows for the backend parameter to default to Cldr.default_backend/0Changelog for Cldr_Units v2.5.0This is the changelog for Cldr_units v2.5.0 released on March 28th, 2019. For older changelogs please consult the release tag on GitHubEnhancementsUpdates to CLDR version 35.0.0 released on March 27th 2019.Changelog for Cldr_Units v2.4.0This is the changelog for Cldr_units v2.4.0 released on March 23rd, 2019. For older changelogs please consult the release tag on GitHubEnhancementsSupports Cldr.default_backend() as a default for backend parameters in Cldr.UnitChangelog for Cldr_Units v2.3.3This is the changelog for Cldr_units v2.3.2 released on March 23rd, 2019. For older changelogs please consult the release tag on GitHubBug FixesInclude priv directory in the hex package (thats where the conversion json exists)Changelog for Cldr_Units v2.3.2This is the changelog for Cldr_units v2.3.2 released on March 20th, 2019. For older changelogs please consult the release tag on GitHubBug FixesFix dialyzer warningsChangelog for Cldr_Units v2.3.1This is the changelog for Cldr_units v2.3.1 released on March 15th, 2019. For older changelogs please consult the release tag on GitHubEnhancementsMakes generation of documentation for backend modules optional. This is implemented by the :generate_docs option to the backend configuration. The default is true. For example:defmodule MyApp.Cldr do use Cldr, default_locale: &quot;en-001&quot;, locales: [&quot;en&quot;, &quot;ja&quot;], gettext: MyApp.Gettext, generate_docs: false endChangelog for Cldr_Units v2.3.0This is the changelog for Cldr_units v2.3.0 released on March 4th, 2019. For older changelogs please consult the release tag on GitHubEnhancementsThe conversion tables are now stored as json and updates may be downloaded at any time with the mix task mix cldr.unit.download. This means that updates to the conversion table may be made without requiring a new release of Cldr.Unit.Changelog for Cldr_Units v2.2.0This is the changelog for Cldr_units v2.2.0 released on February 24th, 2019. For older changelogs please consult the release tag on GitHubEnhancementsThis release is primarily about improving the conversion of units without introducing precision errors that accumulate for floats. The strategy is to define the conversion value between individual unit pairs.Currently the implementation uses a static map. In order to give users a better experience a future release will allow for both specifying mappings as a parameter to Cldr.Unit.convert/2 and as compile time configuration options including the option to download conversion tables from the internet.Direct conversions are now supported. For some calculations, the process of diving and multiplying by conversion factors produces an unexpected result. Some direct conversions are now defined which produce a more expected result.In most cases, return integer values from conversion and decomposition when the originating unit value is also an integerChangelog for Cldr_Units v2.1.0This is the changelog for Cldr_units v2.1.0 released on December 8th, 2018. For older changelogs please consult the release tag on GitHubEnhancementsAdd Cldr.Unit.Conversion.convert!/2Add Cldr.Unit.Math.cmp/2Add Cldr.Unit.decompose/2Add Cldr.Unit.zero/1Add Cldr.Unit.zero?/1The appropriate backend equivalents are also added.Changelog for Cldr_Units v2.0.0This is the changelog for Cldr_units v2.0.0 released on November 24th, 2018. For older changelogs please consult the release tag on GitHubBreaking changesCldr.Unit now requires a Cldr backend module to be configuredIn order for the String.Chars protocol to be supported (which is used in string interpolation and by Kernel.to_string/1) a default backend must be configured. For example in config.exs:config :ex_cldr_units, default_backend: MyApp.CldrEnhancementsMove to a backend module structure with ex_cldr version 2.0","ref":"changelog.html","title":"Changelog for Cldr_Units v3.1.2","type":"extras"},{"doc":"","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Copyright 2017 Kip ColeLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#license","title":"LICENSE - License","type":"extras"}]